// #autoload
// #name = RaceMod ClientSide "pack"
// #version = 1.0
// #date = 3/1/02
// #status = Current
// #description = Fixes: Objectivehud; Additions: transbottomprint
// #author = MeBaD
// #email = webmaster@kilznation.com
// #category = RaceMod

package RaceModCS {

	function setupObjHud(%gameType) {
		//error ("Settings up Objectivehud for: " @ %gameType);

		if (%gameType $= "RaceGame") { // replicate the bountyhud style
			if (isObject(ProHudScore)) {
				error ("You got a REAL objectivehud :D");
				$ProSingleScore = "<color:00FF00>BestFinish<color:FF0000> / <color:FFFF00>Rank<color:FF0000>\n";
				$ProScore[1] = "<color:00FF00>- - - <color:FF0000> / <color:FFFF00>None Yet";
				UpdateProScore(1);
				$RaceGameBestFinishTime = "- - - ";
			}
			// set separators
			objectiveHud.setSeparators("100");
			objectiveHud.disableHorzSeparator();

			// Lap/race time label ("RaceFinishTime")
			objectiveHud.racetimelabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 3";
				extent = "80 40";
				visible = "1";
				text = "Best Finish Time";
			};
			// Your best laptime
			objectiveHud.racetimetext = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "110 3";
				extent = "90 16";
				visible = "1";
				text = "- - -";
			};
			// Rank
			objectiveHud.rankLabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 19";
				extent = "80 16";
				visible = "1";
				text = "Score Rank";
			};
			// Rank of j00
			objectiveHud.ranktext = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "110 19";
				extent = "90 16";
				visible = "1";
				text = "None";
			};

			objectiveHud.add(objectiveHud.racetimelabel);
			objectiveHud.add(objectiveHud.racetimetext);
			objectiveHud.add(objectiveHud.ranklabel);
			objectiveHud.add(objectiveHud.ranktext);
		}
		parent::setupObjHud(%gameType);
	}

	function UpdateObjRaceTime(%junk1, %junk2, %laptime, %isnew, %rank) {
		if (strlen(%isnew) > 5) { // msg if it's new .. null if not :)
			if (isObject(ProHudScore)) { 
				$RaceGameBestFinishTime = %laptime;
			}
			objectiveHud.racetimetext.setValue(%laptime);
		}
		
		if (isObject(ProHudScore)) { 
			// always update the rank, only update the the laptime if they break their old rec :)
			$ProScore[1] = "<font:univers bold:16><color:00FF00>" @ $RaceGameBestFinishTime @ "<color:FF0000> / <color:FFFF00>" @ %rank;
			UpdateProScore(1);
		}

		objectiveHud.ranktext.setValue(%rank);
	}

	function DispatchLaunchMode(%this) {
		addMessageCallback('msgRaceTime', UpdateObjRaceTime);
		schedule(3000, 0, "l33tbottomprint");
		parent::DispatchLaunchMode(%this);
	}

	function l33tbottomprint() {
		// omg .. that big bar is anoying !!!! not anymore :D
		bottomprintdlg.profile = "GuiDefaultProfile";
	}
};
activatePackage(RaceModCS);